IF EXISTS (SELECT * FROM SYSOBJECTS O, sysusers U
           WHERE O.NAME = 'LOG_EST_INVENTESTCEG' AND
                 TYPE = 'TR' 		                AND
	              U.UID = O.UID                   AND
	              U.NAME = USER)
DROP TRIGGER LOG_EST_INVENTESTCEG
GO


CREATE  TRIGGER LOG_EST_INVENTESTCEG
ON INVENTESTCEGO
FOR INSERT,UPDATE,DELETE
AS
   DECLARE  @V_USUARIO   VARCHAR(40);
   DECLARE  @V_TIPO      VARCHAR(1);
   DECLARE  @V_ITPESQ    VARCHAR(40);
   DECLARE  @V_DESC      VARCHAR(300);
   DECLARE  @V_DTOPER    DATETIME;

/*VARIVEIS DO CURSOR C_CURSOR*/

   DECLARE @V_ID_COMANDO        VARCHAR(1) ;
   DECLARE @V_CDFILIAL_OLD         VARCHAR(4);
   DECLARE @V_CDALMOXARIFE_OLD     VARCHAR(6);
   DECLARE @V_CDLOCALESTOQ_OLD     VARCHAR(6);
   DECLARE @V_DTCONTAGEM_OLD       DATETIME;
   DECLARE @V_DTGERACAOINVEST_OLD  DATETIME;
   DECLARE @V_IDSITESTCEGO_OLD     VARCHAR(2);
   DECLARE @V_DTAPROVINVESTCE_OLD  DATETIME;
   DECLARE @V_IDSITUACEITEINV_OLD  VARCHAR(1);
   DECLARE @V_IDINVGERAAJUSTE_OLD  VARCHAR(1);
   DECLARE @V_CDOPERADOR_OLD       VARCHAR(12);
   DECLARE @V_CDFILIAL_NEW         VARCHAR(4);
   DECLARE @V_CDALMOXARIFE_NEW     VARCHAR(6);
   DECLARE @V_CDLOCALESTOQ_NEW     VARCHAR(6);
   DECLARE @V_DTCONTAGEM_NEW       DATETIME;
   DECLARE @V_DTGERACAOINVEST_NEW  DATETIME;
   DECLARE @V_IDSITESTCEGO_NEW     VARCHAR(2);
   DECLARE @V_DTAPROVINVESTCE_NEW  DATETIME;
   DECLARE @V_IDSITUACEITEINV_NEW  VARCHAR(1);
   DECLARE @V_IDINVGERAAJUSTE_NEW  VARCHAR(1);
   DECLARE @V_CDOPERADOR_NEW       VARCHAR(12);

BEGIN

   SET @V_DESC     = '';
   SET @V_TIPO     = '0';

   EXEC NMUSUARIO @V_USUARIO;
   SET @V_USUARIO = ISNULL(@V_USUARIO, ' ');

   DECLARE C_CURSOR CURSOR FOR

      SELECT
         'U' IDCOMANDO,
      DELETED.CDFILIAL,
      DELETED.CDALMOXARIFE,
      DELETED.CDLOCALESTOQ,
      DELETED.DTCONTAGEM,
      DELETED.DTGERACAOINVEST,
      DELETED.IDSITESTCEGO,
      DELETED.DTAPROVINVESTCE,
      DELETED.IDSITUACEITEINV,
      DELETED.IDINVGERAAJUSTE,
      DELETED.CDOPERADOR,
   	INSERTED.CDFILIAL,
      INSERTED.CDALMOXARIFE,
      INSERTED.CDLOCALESTOQ,
      INSERTED.DTCONTAGEM,
      INSERTED.DTGERACAOINVEST,
      INSERTED.IDSITESTCEGO,
      INSERTED.DTAPROVINVESTCE,
      INSERTED.IDSITUACEITEINV,
      INSERTED.IDINVGERAAJUSTE,
      INSERTED.CDOPERADOR

   FROM
      INSERTED,
      DELETED
   WHERE
       INSERTED.CDFILIAL     = DELETED.CDFILIAL
   AND INSERTED.CDALMOXARIFE = DELETED.CDALMOXARIFE
   AND INSERTED.CDLOCALESTOQ = DELETED.CDLOCALESTOQ
   AND INSERTED.DTCONTAGEM   = DELETED.DTCONTAGEM

   UNION ALL

   SELECT
      'I' IDCOMANDO,
      NULL,
      NULL,
      NULL,
      NULL,
      NULL,
      NULL,
      NULL,
      NULL,
      NULL,
      NULL,

      INSERTED.CDFILIAL,
      INSERTED.CDALMOXARIFE,
      INSERTED.CDLOCALESTOQ,
      INSERTED.DTCONTAGEM,
      INSERTED.DTGERACAOINVEST,
      INSERTED.IDSITESTCEGO,
      INSERTED.DTAPROVINVESTCE,
      INSERTED.IDSITUACEITEINV,
      INSERTED.IDINVGERAAJUSTE,
      INSERTED.CDOPERADOR

   FROM
      INSERTED
   WHERE
       CDFILIAL      NOT IN (SELECT  CDFILIAL      FROM DELETED)
   AND CDALMOXARIFE  NOT IN (SELECT  CDALMOXARIFE  FROM DELETED)
   AND CDLOCALESTOQ  NOT IN (SELECT  CDLOCALESTOQ  FROM DELETED)
   AND DTCONTAGEM    NOT IN (SELECT  DTCONTAGEM    FROM DELETED)

   UNION ALL

   SELECT
         'D' IDCOMANDO,
      DELETED.CDFILIAL,
      DELETED.CDALMOXARIFE,
      DELETED.CDLOCALESTOQ,
      DELETED.DTCONTAGEM,
      DELETED.DTGERACAOINVEST,
      DELETED.IDSITESTCEGO,
      DELETED.DTAPROVINVESTCE,
      DELETED.IDSITUACEITEINV,
      DELETED.IDINVGERAAJUSTE,
      DELETED.CDOPERADOR,
      NULL,
      NULL,
      NULL,
      NULL,
      NULL,
      NULL,
      NULL,
      NULL,
      NULL,
      NULL

   FROM
      DELETED
   WHERE
       CDFILIAL      NOT IN (SELECT  CDFILIAL      FROM INSERTED)
   AND CDALMOXARIFE  NOT IN (SELECT  CDALMOXARIFE  FROM INSERTED)
   AND CDLOCALESTOQ  NOT IN (SELECT  CDLOCALESTOQ  FROM INSERTED)
   AND DTCONTAGEM    NOT IN (SELECT  DTCONTAGEM    FROM INSERTED);


   OPEN C_CURSOR;
   FETCH NEXT FROM C_CURSOR INTO @V_ID_COMANDO,
                                 @V_CDFILIAL_OLD,
                                 @V_CDALMOXARIFE_OLD,
                                 @V_CDLOCALESTOQ_OLD,
                                 @V_DTCONTAGEM_OLD,
                                 @V_DTGERACAOINVEST_OLD,
                                 @V_IDSITESTCEGO_OLD,
                                 @V_DTAPROVINVESTCE_OLD,
                                 @V_IDSITUACEITEINV_OLD,
                                 @V_IDINVGERAAJUSTE_OLD,
                                 @V_CDOPERADOR_OLD,
                                 @V_CDFILIAL_NEW,
                                 @V_CDALMOXARIFE_NEW,
                                 @V_CDLOCALESTOQ_NEW,
                                 @V_DTCONTAGEM_NEW,
                                 @V_DTGERACAOINVEST_NEW,
                                 @V_IDSITESTCEGO_NEW,
                                 @V_DTAPROVINVESTCE_NEW,
                                 @V_IDSITUACEITEINV_NEW,
                                 @V_IDINVGERAAJUSTE_NEW,
                                 @V_CDOPERADOR_NEW;

   WHILE (@@FETCH_STATUS = 0) BEGIN

      IF NOT @V_USUARIO IS NULL BEGIN
         IF @V_ID_COMANDO= 'D' /*DELETING*/ BEGIN
            SET @V_TIPO = '3';
            IF @V_CDFILIAL_OLD IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC + 'CodFilial=' + @V_CDFILIAL_OLD;
            END;
            IF @V_CDALMOXARIFE_OLD IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC + ' CodAlmoxarife=' + @V_CDALMOXARIFE_OLD;
            END;
            IF @V_CDLOCALESTOQ_OLD IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC + ' CodLocalEstoq=' + @V_CDLOCALESTOQ_OLD;
            END;
            IF @V_DTCONTAGEM_OLD IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC + ' DataContagem=' + CONVERT(VARCHAR,@V_DTCONTAGEM_OLD);
            END;
            IF @V_DTGERACAOINVEST_OLD IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC + ' DtGeracaoInvEst=' + CONVERT(VARCHAR,@V_DTGERACAOINVEST_OLD);
            END;
            IF @V_IDSITESTCEGO_OLD IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC + ' SitEstCego=' + @V_IDSITESTCEGO_OLD;
            END;
            IF @V_DTAPROVINVESTCE_OLD IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC + ' DtAprovInvEstCego=' + CONVERT(VARCHAR,@V_DTAPROVINVESTCE_OLD);
            END;
            IF @V_IDSITUACEITEINV_OLD IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC + ' SitAceiteInv=' + @V_IDSITUACEITEINV_OLD;
            END;
            IF @V_IDINVGERAAJUSTE_OLD IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC + ' InvGeraAjuste=' + @V_IDINVGERAAJUSTE_OLD;
            END;
            IF @V_CDOPERADOR_OLD IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC + ' CodOperador=' + @V_CDOPERADOR_OLD;
            END;

            SET @V_ITPESQ = @V_CDFILIAL_OLD + @V_CDALMOXARIFE_OLD + @V_CDLOCALESTOQ_OLD + CONVERT(VARCHAR,@V_DTCONTAGEM_OLD);
        END
        ELSE BEGIN
        	  IF @V_ID_COMANDO= 'U' /*UPDATING*/ BEGIN

              IF (@V_CDFILIAL_OLD     <> @V_CDFILIAL_NEW)       OR
                 (@V_CDALMOXARIFE_OLD <> @V_CDALMOXARIFE_NEW)   OR
                 (@V_CDLOCALESTOQ_OLD <> @V_CDLOCALESTOQ_NEW)   OR
                 (ISNULL(@V_DTCONTAGEM_OLD, CONVERT(DATETIME,NULL))   <> ISNULL(@V_DTCONTAGEM_NEW, CONVERT(DATETIME,NULL)))     OR
                 (ISNULL(@V_DTGERACAOINVEST_OLD, CONVERT(DATETIME,NULL)) <> ISNULL(@V_DTGERACAOINVEST_NEW, CONVERT(DATETIME,NULL))) OR
                 (@V_IDSITESTCEGO_OLD   <> @V_IDSITESTCEGO_NEW) OR
                 (ISNULL(@V_DTAPROVINVESTCE_OLD, CONVERT(DATETIME,NULL)) <> ISNULL(@V_DTAPROVINVESTCE_NEW, CONVERT(DATETIME,NULL))) OR
                 (@V_IDSITUACEITEINV_OLD <> @V_IDSITUACEITEINV_NEW)   OR
                 (@V_IDINVGERAAJUSTE_OLD <> @V_IDINVGERAAJUSTE_NEW)   OR
                 (ISNULL(@V_CDOPERADOR_OLD, 'NULO') <> ISNULL(@V_CDOPERADOR_NEW, 'NULO')) BEGIN

                 SET  @V_TIPO   = '2';
                 SET  @V_ITPESQ = @V_CDFILIAL_OLD + @V_CDALMOXARIFE_OLD + @V_CDLOCALESTOQ_OLD + CONVERT(VARCHAR,@V_DTCONTAGEM_OLD);

              END;
           END
        	  ELSE BEGIN
           		SET @V_TIPO   = '1';
               SET  @V_ITPESQ = @V_CDFILIAL_NEW + @V_CDALMOXARIFE_NEW + @V_CDLOCALESTOQ_NEW + CONVERT(VARCHAR,@V_DTCONTAGEM_NEW);
           END;
        END;
      END;

      IF (@V_ID_COMANDO= 'I') OR (@V_ID_COMANDO='U') BEGIN
         IF ISNULL(@V_CDFILIAL_OLD, '!') <> ISNULL(@V_CDFILIAL_NEW, '!') BEGIN
            SET @V_DESC = @V_DESC + ' CodFilial=' + @V_CDFILIAL_NEW;
         END;
         IF ISNULL(@V_CDALMOXARIFE_OLD, '!') <> ISNULL(@V_CDALMOXARIFE_NEW, '!') BEGIN
            SET @V_DESC = @V_DESC + ' CodAlmoxarife=' + @V_CDALMOXARIFE_NEW;
         END;
         IF ISNULL(@V_CDLOCALESTOQ_OLD, '!') <> ISNULL(@V_CDLOCALESTOQ_NEW, '!') BEGIN
            SET @V_DESC = @V_DESC + ' CodLocalEstoq=' + @V_CDLOCALESTOQ_NEW;
         END;
         IF ISNULL(@V_DTCONTAGEM_OLD, CONVERT(DATETIME,NULL)) <> ISNULL(@V_DTCONTAGEM_NEW, CONVERT(DATETIME,NULL)) BEGIN
            SET @V_DESC = @V_DESC + ' DataContagem=' + CONVERT(VARCHAR,@V_DTCONTAGEM_NEW);
         END;
         IF ISNULL(@V_DTGERACAOINVEST_OLD, CONVERT(DATETIME,NULL)) <> ISNULL(@V_DTGERACAOINVEST_NEW, CONVERT(DATETIME,NULL)) BEGIN
            SET @V_DESC = @V_DESC + ' DataGeracaoInv=' + CONVERT(VARCHAR,@V_DTGERACAOINVEST_NEW);
         END;
         IF ISNULL(@V_IDSITESTCEGO_OLD, '!') <> ISNULL(@V_IDSITESTCEGO_NEW, '!') BEGIN
            SET @V_DESC = @V_DESC + ' SitEstCego=' + @V_IDSITESTCEGO_NEW;
         END;
         IF ISNULL(@V_DTAPROVINVESTCE_OLD, CONVERT(DATETIME,NULL)) <> ISNULL(@V_DTAPROVINVESTCE_NEW, CONVERT(DATETIME,NULL)) BEGIN
            SET @V_DESC = @V_DESC + ' DataAprovInv=' + @V_DTAPROVINVESTCE_NEW;
         END;
         IF ISNULL(@V_IDSITUACEITEINV_OLD, '!') <> ISNULL(@V_IDSITUACEITEINV_NEW, '!') BEGIN
            SET @V_DESC = @V_DESC + ' SitAceiteInv=' + @V_IDSITUACEITEINV_NEW;
         END;
         IF ISNULL(@V_CDOPERADOR_OLD, '!') <> ISNULL(@V_CDOPERADOR_NEW, '!') BEGIN
            SET @V_DESC = @V_DESC + ' CodOperador=' + @V_CDOPERADOR_NEW;
         END;
      END;

      IF (@V_TIPO <> '0')  BEGIN
         IF NOT @V_DESC IS NULL BEGIN
            EXEC NMUSUARIO @V_USUARIO;
            SET  @V_DTOPER = GETDATE();
            INSERT INTO LOGOPERA
                     (  NMTABELA,       DTOPERACAO,NMRESPOPER,
                        IDTIPOOPER, CDPESQITEM,DSOPERACAO)
               VALUES
                     ('INVENTESTCEGO', @V_DTOPER, @V_USUARIO,
                        @V_TIPO,    @V_ITPESQ, @V_DESC);
         END;
      END;
      FETCH NEXT FROM C_CURSOR INTO @V_ID_COMANDO,

         @V_CDFILIAL_OLD,
         @V_CDALMOXARIFE_OLD,
         @V_CDLOCALESTOQ_OLD,
         @V_DTCONTAGEM_OLD,
         @V_DTGERACAOINVEST_OLD,
         @V_IDSITESTCEGO_OLD,
         @V_DTAPROVINVESTCE_OLD,
         @V_IDSITUACEITEINV_OLD,
         @V_IDINVGERAAJUSTE_OLD,
         @V_CDOPERADOR_OLD,
         @V_CDFILIAL_NEW,
         @V_CDALMOXARIFE_NEW,
         @V_CDLOCALESTOQ_NEW,
         @V_DTCONTAGEM_NEW,
         @V_DTGERACAOINVEST_NEW,
         @V_IDSITESTCEGO_NEW,
         @V_DTAPROVINVESTCE_NEW,
         @V_IDSITUACEITEINV_NEW,
         @V_IDINVGERAAJUSTE_NEW,
         @V_CDOPERADOR_NEW;

   END;

   CLOSE      C_CURSOR;
   DEALLOCATE C_CURSOR;
END;
 GO


 -- VERSAO --
 EXEC ATUVEROBJ 'LOG_EST_INVENTESTCEGO','5.05.004';
 GO
