var Configuration;
var moment;
var getLocalVar;
var Util;
var angular;
let messages = {
    errosApuracao: "Erros na Apuração",
    timeout: "Tempo limite de conexão excedido."
};

function opl00900_listagem_de_corteController(General, Utilities, RestEngine, ScreenService, MessageService, templateManager, maskEngine, ZhUtil, ZHPromise){

    this.startScreen = function(widget) {
        widget.newRow();
        this.setFilterInitValues(widget);
    };
    
    this.setFilterInitValues = function(widget){
	    widget.currentRow.L_PER_LEV_PREV_CONS = {};
	    widget.currentRow.L_PER_LEV_PREV_CONS.formattedStart = moment().format('L');
        widget.currentRow.L_PER_LEV_PREV_CONS.formattedEnd = moment().format('L');
	    widget.currentRow.L_PER_LEV_PREV_CONS.start = moment().format('L');
        widget.currentRow.L_PER_LEV_PREV_CONS.end = moment().format('L');
        
	    widget.currentRow.L_PER_LEV_AF = {};
	    widget.currentRow.L_PER_LEV_AF.formattedStart = moment().format('L');
        widget.currentRow.L_PER_LEV_AF.formattedEnd = moment().format('L');
	    widget.currentRow.L_PER_LEV_AF.start = moment().format('L');
        widget.currentRow.L_PER_LEV_AF.end = moment().format('L');
    };
    
    this.selectUnidades = function(widget) {
        var regiao = (widget.currentRow.L_REGIAO) ? widget.currentRow.L_REGIAO.join('_') :  'T';
        var filterName = regiao === 'T' ? "P_TCDREGIAO" : "P_CDREGIAO";
        widget.getField('L_FILIAL').dataSource.name = "opl_relatorios#/crud/opl00900_filial_regiao";
        widget.getField('L_FILIAL').dataSourceFilter = [
            {
                "name": filterName,
                "operator": "=",
                "value": regiao
            }
        ];
        
        widget.getField('L_FILIAL').reload();
        this.setNGeracaoNull(widget);
    };
    
    this.setUnidadesNull = function(widget){
        widget.getField('L_FILIAL').clearValue();
    };
    
    this.selectNGeracao = function(widget) {
        if(widget.currentRow.L_FILIAL) {
            var filial = widget.currentRow.CDFILIAL;
            widget.getField('NR_GERACAO').dataSource.name = "opl_relatorios#/crud/opl00900_nr_geracao";
            widget.getField('NR_GERACAO').dataSourceFilter = [
                {
                    "name": "P_CDFILIOPELOG",
                    "operator": "=",
                    "value": filial
                }
            ];
            widget.getField('NR_GERACAO').reload();
        } else {
            this.setNGeracaoNull(widget);
            this.setUnidadesNull(widget);
            MessageService.showMessageByCode("L_FILIAL_VAZIA");
        }
    };
    
    this.setNGeracaoNull = function(widget) {
        widget.getField('NR_GERACAO').clearValue();
    };
    
    this.verificaNGeracao = function(args) {
		var widget = args.owner.field.widget;
		var row = widget.currentRow;
		var filialIsSet = this.fieldIsSet(row.L_FILIAL);
        if(!filialIsSet) {
			widget.currentRow.NR_GERACAO = '';
			widget.currentRow.CDFILIAL = '';
			if(widget.name === "opl00900") {
                widget.getField('NR_GERACAO').readOnly = true;
                widget.getField('NR_GERACAO').readOnlyOnEdit = true;
                this.setNGeracaoNull(widget);
			}
        } else if(widget.name === "opl00900") {
            widget.getField('NR_GERACAO').readOnly = false;
            widget.getField('NR_GERACAO').readOnlyOnEdit = false;
            this.setNGeracaoNull(widget);
        }
    };

	this.fieldIsSet = function(fieldValue) {
		if (fieldValue) return true;
		else return false;
	};
	
	this.filterProdIni = function(args) {
		var widget = args.owner.field.widget;
		var row = widget.currentRow;
		var prodIniIsSet = this.fieldIsSet(row.CDPRODINI);
		if(!prodIniIsSet) {
			widget.currentRow.NMPRODFIN = '';
			widget.currentRow.CDPRODFIN = '';
			if(widget.name === "opl00900") {
                widget.getField('NMPRODFIN').readOnly = true;
                widget.getField('NMPRODFIN').readOnlyOnEdit = true;
                widget.getField('NMPRODFIN').clearValue();
			}
		} else if(widget.name === "opl00900") {
            widget.getField('NMPRODFIN').readOnly = false;
            widget.getField('NMPRODFIN').readOnlyOnEdit = false;
		}
        this.checkProductRange(args.owner.field);
	};
	
	this.filterProdFin = function(args) {
		var widget = args.owner.field.widget;
		var row = widget.currentRow;
		var prodFinIsSet = this.fieldIsSet(row.CDPRODFIN);
		var prodIniIsSet = this.fieldIsSet(row.CDPRODINI);
		if (prodFinIsSet) {
			if (row.CDPRODINI > row.CDPRODFIN) {
                MessageService.showMessageByCode("PRODUTO_INICIAL_MENOR_IGUAL_FINAL");
			}
		} else if(!prodIniIsSet) {
            widget.getField('NMPRODFIN').readOnly = true;
            widget.getField('NMPRODFIN').readOnlyOnEdit = true;
            widget.getField('NMPRODFIN').clearValue();
		}
		this.checkProductRange(args.owner.field);
	};
	
	this.checkProductRange = function(field) {
	   var currentRow = field.widget.currentRow;

		if (currentRow.CDPRODINI && currentRow.CDPRODFIN) {
			var compproduto = (currentRow.CDPRODFIN) ? currentRow.CDPRODFIN.replace(/[\.\-]/g, '') : null;

			if (!this.comparaPratoProduto(currentRow.CDPRODINI, compproduto, getLocalVar('CDPICTPROD'))) {
				currentRow[field.outData[field.descriptionField]] = null;
				currentRow[field.outData[field.valueField]] = null;

                field.widget.getField('NMPRODINI').clearValue();
                field.widget.getField('NMPRODFIN').clearValue();
                MessageService.showMessageByCode("PRODUTO_INICIAL_MENOR_IGUAL_FINAL");
			}
		}
	};
	
	this.comparaPratoProduto = function(pinicial, pfinal, mascara) {
        var mask = {
          type: "fix",
          params: {
              mask: mascara
          }
        };
        pinicial = Util.applyMask(pinicial, mask, maskEngine, ZhUtil).split('.');
        pfinal = Util.applyMask(pfinal, mask, maskEngine, ZhUtil).split('.');
        var nvinicial = pinicial.length;
        var nvfinal = pfinal.length;
        var resultado = true;
        if(nvinicial != nvfinal) {
            if(nvinicial > nvfinal) {
                resultado = false;
            }
        } else {
            var i = 0;
            do {
                if(pinicial[i] > pfinal[i]) {
                    resultado = false;
                }
                i++;
            }
            while (i<pinicial.length && resultado);
        }
        return resultado;
    };
    
    this.verificaRelatorio = function(widget) {
        var currentRow = widget.currentRow;
        if(widget.isValid()) {
            var reportName = currentRow.REPORT_NAME;
            General.openReportPopup(widget, this.abreRelatorio, [widget, currentRow, reportName]);
        }
    };
    
    //Verifica o formulário e valida o COMPRADOR
    this.verificaFormForCalculo = function(widget) {
        if(widget.isValid()) {
            this.openLoginValidation(widget);
        }
    };
    
    this.abreRelatorio = function(widget, currentRow, reportName) {
        var row = angular.copy(currentRow);
        row.P_CDFILIALOL = row.CDFILIAL;
        if(Array.isArray(row.NR_GERACAO) && row.NR_GERACAO.length > 0) {
           row.P_NRLOGCORTEOL = row.NR_GERACAO.join('_');
        }
        row.P_DTINICIAL = row.L_PER_LEV_PREV_CONS.start;
        row.P_DTFINAL = row.L_PER_LEV_PREV_CONS.end;
        row.P_DTINICIALAF = row.L_PER_LEV_AF.start;
        row.P_DTFINALAF = row.L_PER_LEV_AF.end;
        row.P_CDREGIAO = row.L_REGIAO ? Array.isArray(row.L_REGIAO) && row.L_REGIAO.length > 0 ? row.L_REGIAO.join('_') : 'T' : 'T';
        row.P_CDOPERADOR = row.L_COMPRADOR ? Array.isArray(row.L_COMPRADOR) && row.L_COMPRADOR.length > 0 ? row.L_COMPRADOR.join('_') : 'T' : 'T';
        row.P_CDPRODINIC = row.CDPRODINI;
        if(row.CDPRODFIN) {
            let concatString = row.CDPRODFIN.concat('ZZZZZZZZZZZZZZZZZZZZ');
            row.P_CDPRODFIN = concatString.substring(0, 20);
        } else {
            row.P_CDPRODFIN = 'ZZZZZZZZZZZZZZZZZZZZ';
        }
        row.P_GERACMP = 'N';
        row.P_ANALITICO = row.ANALITICO;
        row.NRORG = getLocalVar('NRORG');
        General.openReport("opl_relatorios#/opl00900_relatorio", reportName, row);
    };
    
    //Abre o form para Login
    this.openLoginValidation = function(widget) {
        
        var DTINICIAL = widget.currentRow.L_PER_LEV_PREV_CONS.start;
        var DTFINAL = widget.currentRow.L_PER_LEV_PREV_CONS.end;
        var DTINICIALAF = widget.currentRow.L_PER_LEV_AF.start;
        var DTFINALAF = widget.currentRow.L_PER_LEV_AF.end;

        if(DTINICIAL != "" && DTFINAL != "" && widget.currentRow.L_COMPRADOR != "" || DTINICIALAF != "" && DTFINALAF != "" && widget.currentRow.L_COMPRADOR != "") {
            if (widget.currentRow.L_COMPRADOR.length === 1) {
                General.callRestEngine("opl_relatorios#/compValidation", "Row", {
                    "CDCOMPRADOR": widget.currentRow.L_COMPRADOR[0],
                    "CDOPERADOR": getLocalVar('CDOPERADOR'),
                    "CDCENTCMP": getLocalVar('CDFILIAL')
                }).then(function(response) {
                    if (response.dataset.passwordAut.PARAM === 'S') {
                        widget.container.getWidget('LOGIN').currentRow.CDCOMPRADOR = widget.currentRow.L_COMPRADOR[0];
                        widget.container.getWidget('LOGIN').currentRow.CDOPERADOR = getLocalVar('CDOPERADOR');
                        ScreenService.openPopup(widget.container.getWidget('LOGIN'));
                    } else if(response.dataset.passwordAut.PARAM === 'N') {
                        ScreenService.showMessage('Operador não autorizado a realizar apuração para o comprador.', 'error', 'error');
                    }
                }).catch(function(error) {
                    ScreenService.showMessage(error.data ? error.data.error : messages.timeout, 'error', 'error');
                    widget.currentRow.CDCOMPRADOR = "";
                });
            } else {
                ScreenService.showMessage('Deve ser informado apenas 1 comprador.', 'error', 'error');
            }
        } else {
            if(widget.currentRow.L_COMPRADOR == ""){
                ScreenService.showMessage('Informe um Comprador.', 'error', 'error');
            } else if (DTINICIAL == "" && DTFINAL == "" || DTINICIALAF == "" && DTFINALAF == "") {
                ScreenService.showMessage('Informe um Periodo de Levantamento.', 'error', 'error');
            }
        }
    };

    //Valida o Login
    this.loginValidation = function(widget) {
        if(!Util.isEmptyOrBlank(widget.currentRow.PASSWORD)){
            General.callRestEngine("opl_relatorios#/passwordValidation", "Row", widget.currentRow).then(function(response) {
                widget.currentRow = {};
                ScreenService.closePopup();
                //Chama a procedure 
                procedureCalcular();
            }).catch(function(error) {
                ScreenService.showMessage(error.data.error);
                widget.currentRow.PASSWORD = "";
            });
        } else {
            ScreenService.showMessage('Senha deve ser informada.', 'exclamation', 'exclamation');
        }
    };
    
    //Executa procedure 
    var procedureCalcular = function() {
        var widget = templateManager.container.getWidget('opl00900');
        ScreenService.showLoader();
        General.callRestEngine("opl_relatorios#/getGeraCorteOL", "Row", {
            "P_CDFILIOPELOG": widget.currentRow.CDFILIAL,
            "P_CDFILLANC": widget.currentRow.CDFILIAL,
            "P_CDOPERLANC": getLocalVar('CDOPERADOR'),
            "P_DTINICIAL": widget.currentRow.L_PER_LEV_PREV_CONS,
            "P_DTFINAL": widget.currentRow.L_PER_LEV_PREV_CONS,
            "P_DTINICIALAF": widget.currentRow.L_PER_LEV_AF,
            "P_DTFINALAF": widget.currentRow.L_PER_LEV_AF,
            "P_TIPOCONSULTA": '',
            "P_COMPRADOR": widget.currentRow.L_COMPRADOR[0],
            "P_CDREGIAO": widget.currentRow.L_REGIAO ? Array.isArray(widget.currentRow) && widget.currentRow.L_REGIAO.length > 0 ? widget.currentRow.L_REGIAO.join('_') : 'T' : 'T',
            "P_CDPRODINIC": widget.currentRow.CDPRODINI,
            "P_CDPRODFIN": (widget.currentRow.CDPRODFIN + "ZZZZZZZZZZZZZZZZZZZZ").substr(0, 20),
            "P_DTPROCESSA": getLocalVar('DTPROCESSA')
        }).then(function(response) {
            //Armazena o result
            response = response.dataset.result[0];
            if (response === "NN") {
                ScreenService.showMessage('Não há dados para apuração/efetivação do OL.', 'error', 'error');
            } else {
                if (response.substr(12,1) === "N") {
                    ScreenService.showMessage('Não há dados para verificação de inconsistência do OL, favor verificar se já existe AF para o período informado.', 'error', 'error');
                } else {
                    //Abre popup com pergunta, caso SIM, cria relatório de inconsistencia
                    ScreenService.confirmMessage('Deseja verificar se existe inconsitências na Apuração/Efetivação do OL?', 'question', (success) =>  {
                        // General.callRestEngine("opl_relatorios#/createReportIncon", "Row", {
                        //     "CDFILIAL": widget.currentRow.CDFILIAL,
                        //     "P_CDCOMPRADOR": widget.currentRow.L_COMPRADOR[0],
                        //     "param2": '',
                        //     "param3": '',
                        //     "P_DTINICIAL": widget.currentRow.L_PER_LEV_PREV_CONS.start,
                        //     "P_DTFINAL": widget.currentRow.L_PER_LEV_PREV_CONS.end,
                        //     "P_RESULT": response.substr(1, 10)
                        // }).then(function(response) {
                        //     console.log(response);
                        // });
                        
                        var rowRelatorioInconsistencia = {
                            "CDFILIAL": widget.currentRow.CDFILIAL,
                            "P_CDCOMPRADOR": widget.currentRow.L_COMPRADOR[0],
                            "param2": '',
                            "param3": '',
                            "P_DTINICIAL": widget.currentRow.L_PER_LEV_PREV_CONS.start,
                            "P_DTFINAL": widget.currentRow.L_PER_LEV_PREV_CONS.end,
                            "P_RESULT": response.substr(1, 10)
                        };
                        
                        console.log(rowRelatorioInconsistencia);
                        
                        var reportName = widget.currentRow.REPORT_NAME;
                        General.openReportPopup(widget, this.abreRelatorioInconsistencia, [widget, rowRelatorioInconsistencia, reportName]);
                    }, function(error) {
                        return ScreenService.errorNotification(error, 'ERROR');
                    });
                }
            }
            
            //Se tem response OU se o result é maior que 12(em caracters) e a posição 12 da string é = "N"
            if (!response || response.length >= 13 && response.substr(11,1) === "N") {
                ScreenService.showMessage('Não há dados para apuração/efetivação do OL.', 'error', 'error');
            }
            
            //Após as validações acima, abre a tela de apuração/Efet... OL
            // ScreenService.openWindow('opl_apuracaoEfetivacao#apuracao_efetivacao');
        
        }).catch(function(error) {
            ScreenService.showMessage('Ocorreu um erro ao executar as procedures.', 'error', 'error');
        });
        
        ScreenService.hideLoader();
    };
    
    this.abreRelatorioInconsistencia = function(widget, rowRelatorioInconsistencia, reportName) {
        General.openReport("opl_relatorios#/opl00900_relatorio", reportName, rowRelatorioInconsistencia);
    };
    
}

Configuration(function(ContextRegister){
    ContextRegister.register("opl00900_listagem_de_corteController", opl00900_listagem_de_corteController);
});

